type TPOLY=array of record lat,lon:extended; end;
     TPASMO=record
       LatMin,LatMax,LonMin,LonMax: extended;
       poly:TPOLY;
     end;
var aPasma:array[0..7] of TPASMO;

procedure TPRead(sFile:string; idx:integer); //nacte jeden polygon ze souboru
var s:string;
    i:integer;
    aList:TStringList;
    f:extended;
begin
  aList:=TStringList.Create();
  try
    //Result.LatMin:=9999; Result.LonMin:=9999; Result.LatMax:=-9999; Result.LonMax:=-9999;
    aList.Text:=FileToString(sFile);
    SetLength(aPasma[idx].poly,aList.Count);
    for i:=0 to aList.Count-1 do begin
      s:=aList[i];
      f:=StrToFloat(Fetch(s,','));
      if(aPasma[idx].LatMin>f) then aPasma[idx].LatMin:=f;
      if(aPasma[idx].LatMax<f) then aPasma[idx].LatMax:=f;
      aPasma[idx].poly[i].lat:=f;
      f:=StrToFloat(s);
      if(aPasma[idx].LonMin>f) then aPasma[idx].LonMin:=f;
      if(aPasma[idx].LonMax<f) then aPasma[idx].LonMax:=f;
      aPasma[idx].poly[i].lon:=f;
    end;
  finally
    aList.Free();
  end;
  //zkontrolujeme, zda prvni bod je zaroven poslednim, pokud ne, pridame jej
  i:=Length(aPasma[idx].poly);
  if((aPasma[idx].poly[0]<>aPasma[idx].poly[i-2])
    or (aPasma[idx].poly[1]<>aPasma[idx].poly[i-1])) then begin
    SetLength(aPasma[idx].poly,i+1);
    aPasma[idx].poly[i].lat:=(aPasma[idx].poly[0].lat);
    aPasma[idx].poly[i].lon:=(aPasma[idx].poly[0].lon);
  end;
{$ifdef DEBUG_HELPER}
LDH('Polygon pro tarifni pasmo '+IntToStr(idx)+': pocet bodu: '+IntToStr(i));
{$endif}
end;

procedure TPInit(sDir:string); //nacte polygony tarifnich pasem
var i:integer;
begin
  for i:=0 to 7 do begin
  //for i:=7 to 7 do begin
    TPRead(sDir+'\Pasmo'+intToStr(i)+'.txt',i);
  end;
end;

procedure TPFree;  //uklid
var i:integer;
begin
  for i:=0 to 7 do SetLength(aPasma[i].poly,0);
end;

//funkce zjisti, zda bod [lat,lon] je uvnitr polygonu
function InsidePolygon(lat, lon: extended; idx:integer): Boolean;
var  i,len: integer;
     aPoly:TPOLY;
begin
  Result:=false;
  aPoly:=aPasma[idx].poly;
  len:=Length(aPoly);
  if(len<6) then exit;  //prilis maly polygon - je to jen cara.
  //pokud nejsou souradnice v obdelniku opsanem polygonu, nemuze byt uvnitr!
  if(not((lat>=aPasma[idx].LatMin) and (lat<=aPasma[idx].LatMax)
    and (lon>=aPasma[idx].LonMin) and (lon<=aPasma[idx].LonMax))) then exit;
  //testuj, jestli je bod uvnitr polygonu
  for i:=0 to len-2 do begin
    if(((aPoly[i+1].lon<lon) AND (aPoly[i].lon>=lon))
      OR ((aPoly[i].lon<lon) AND (aPoly[i+1].lon>=lon)))
      AND ((aPoly[i+1].lat<=lat) OR (aPoly[i].lat<=lat)) then
      Result:=Result XOR ((aPoly[i+1].lat+(lon-aPoly[i+1].lon) /
        (aPoly[i].lon-aPoly[i+1].lon)*(aPoly[i].lat-aPoly[i+1].lat)<lat));
  end;
  //SetLength(aPoly,0);
end;

function GetTP(lat,lon:string):integer; //zjisti tarifni pasmo, do ktereho spadaji souradnice
var i:integer;
begin
  Result:=100;
  for i:=0 to 7 do begin
    if(InsidePolygon(StrToFloat(lat),StrToFloat(lon),i)) then begin
      Result:=i;
      break;
    end;
  end;
end;